package com.xjgs.service;

import com.itextpdf.text.*;
import com.itextpdf.text.pdf.*;
import com.xjgs.vo.Fangshe;
import org.apache.commons.lang3.StringUtils;
import org.junit.Test;

import java.io.File;
import java.io.FileOutputStream;

public class ItextPdfImpl{

    public String[] convertMath(String str){
        String[] s = str.split("  ");
        return s;
    }
    public  boolean writePdf(Fangshe source, String temp, String str, String str1, String prof) {
        PdfWriter writer = null;
        Document docPDF = null;
        try {
            docPDF = new Document (PageSize.A4, 25, 1.3F, 40, 0.74F);
            //PageSize.A4.rotate () 为横向
            writer = PdfWriter.getInstance (docPDF, new FileOutputStream (temp));
            docPDF.open ();

            BaseFont baseFont = BaseFont.createFont("C:\\Windows\\Fonts\\simsun.ttc,1", BaseFont.IDENTITY_H,BaseFont.EMBEDDED);
            // 标题
            Font font = new Font(baseFont,16,Font.NORMAL); //正常
            Paragraph paragraph = new Paragraph(14);// 边距
            // 1 2 3 中右左
            paragraph.setAlignment(1); // 对齐方式
            paragraph.setFont(font);// 设置段落字体
            Chunk chunk = new Chunk("英德市人民医院影像中心");
            paragraph.add(chunk);
            docPDF.add(paragraph);


            Paragraph paragraph1 = new Paragraph(14);
            BaseFont bfComic = BaseFont.createFont("c:\\windows\\fonts\\simkai.ttf",
                    BaseFont.IDENTITY_H, BaseFont.NOT_EMBEDDED);
            // 1 2 3 中右左
            Font font2 = new Font(bfComic,20,Font.NORMAL); //正常
            paragraph1.setLeading(20f);// 行间距
            paragraph1.setAlignment(1); // 对齐方式
            paragraph1.setFont(font2);
            Chunk chunk1 = new Chunk(prof);
            paragraph1.add(chunk1);
            docPDF.add(paragraph1);

            PdfPTable t0 = CreateTable0 (source);
            PdfPTable t1 = CreateTable1 (source);
            PdfPTable t2 = CreateTable2 (source);
            PdfPTable t3 = CreateTable3 (source,str,str1);
            docPDF.add (t0);
            docPDF.add (t1);
            docPDF.add (t2);
            docPDF.add (t3);
            PdfPTable t4 = CreateTable4 (source);
            docPDF.add (t4);
            //PdfPTable t5 = AddImage2PDF ("C:\\1102.png");
            //docPDF.add (t5);

        }
        catch (Exception e)
        {
            e.printStackTrace ();
        }finally {
            if(null!=docPDF){
                docPDF.close ();
            }
            if(null !=writer){
                writer.close ();
            }
        }
        File file = new File (temp);
        return file.exists ();
    }

    private final float RowHeight = 20F;
    private  final  String FontName="宋体";
    private PdfPTable CreateTable0(Fangshe obj) throws Exception {
        PdfPTable pt = new PdfPTable (8);
        float[] widthes = new float[]{3F,4F,3F,2F,3F,2F,4F,4F};
        pt.setWidths(widthes);
        pt.setWidthPercentage (95F);

        PdfPCell p11 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "姓    名：");
        PdfPCell p12 = CreateCell (RowHeight,FontName, -1, false,PdfPCell.ALIGN_LEFT , -1, obj.getFIRSTNAME ());
        PdfPCell p13 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "性 别：");
        PdfPCell p14 = CreateCell (RowHeight,FontName, -1, false, -1, -1, obj.getPATIENTSEX ());
        PdfPCell p15 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "年 龄：");
        PdfPCell p16 = CreateCell (RowHeight,FontName, -1, false, -1, -1, obj.getPATIENTAGE ());
        PdfPCell p17 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "检 查 号:");
        PdfPCell p18 = CreateCell (RowHeight,FontName, -1, false, PdfPCell.ALIGN_LEFT, -1, obj.getPATIENT_ID ());


        PdfPRow pr1 = new PdfPRow (new PdfPCell[]{ p11, p12, p13, p14,p15,p16, p17,p18 });
        pt.getRows ().add (pr1);

        PdfPCell p21 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "申请科室：");
        PdfPCell p22 = CreateCell (RowHeight,FontName, 10, false, PdfPCell.ALIGN_LEFT, -1, obj.getREQUESTINGDEPARTMENT ());
        PdfPCell p23 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "床 号：");
        PdfPCell p24 = CreateCell (RowHeight,FontName, -1, false, -1, -1, obj.getBEDID ());
        PdfPCell p25 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "门诊号:");
        PdfPCell p26 = CreateCell (RowHeight,FontName, -1, false, -1, -1, obj.getCLINICAL_ID());
        PdfPCell p27 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "住 院 号:");
        PdfPCell p28 = CreateCell (RowHeight,FontName, -1, false, PdfPCell.ALIGN_LEFT, -1, obj.getINPATIENT_ID());

        PdfPRow pr2 = new PdfPRow (new PdfPCell[]{ p21, p22, p23, p24,p25,p26, p27,p28 });
        pt.getRows ().add (pr2);
        AppendLine (8,pt,false, 2F);

        return pt;
    }
    private  PdfPTable AddImage2PDF(String srcImg) throws Exception {
        Image img = Image.getInstance(srcImg);
        img.setScaleToFitHeight (true);
        PdfPTable pt = new PdfPTable (1);
        float[] widthes = new float[]{10F};
        pt.setWidths(widthes);
        pt.setWidthPercentage (95F);

        PdfPCell p11 = CreateCell (0.1F,FontName, -1, false,Element.ALIGN_RIGHT, -1, "    ");
        p11.addElement(img);


        PdfPRow pr1 = new PdfPRow (new PdfPCell[]{ p11 });
        pt.getRows ().add (pr1);


        return pt;
    }
    private PdfPTable CreateTable1(Fangshe obj) throws Exception {
        PdfPTable pt = new PdfPTable (2);
        float[] widthes = new float[]{2F,8F};
        pt.setWidths(widthes);
        pt.setWidthPercentage (95F);

        PdfPCell p11 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "检查部位：");
        PdfPCell p12 = CreateCell (RowHeight,FontName, -1, false, -1, -1, obj.getREQUESTEDPROCEDUREDESCRIPTION ());


        PdfPRow pr1 = new PdfPRow (new PdfPCell[]{ p11, p12 });
        pt.getRows ().add (pr1);
        return pt;
    }
    private PdfPTable CreateTable2(Fangshe obj) throws Exception {
        PdfPTable pt = new PdfPTable (1);
        float[] widthes = new float[]{2F};
        pt.setWidths(widthes);
        pt.setWidthPercentage (95F);

        PdfPCell p11 = CreateCell (RowHeight,FontName, 14, false, -1, -1, "检查所见：");
        PdfPRow pr1 = new PdfPRow (new PdfPCell[]{ p11});
        pt.getRows ().add (pr1);
        //AppendEmptyLine (2,pt,2F);
        PdfPCell p12 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "    "+obj.getEXAMINEDESCRIPTION ());
        PdfPRow pr2 = new PdfPRow (new PdfPCell[]{ p12});
        pt.getRows ().add (pr2);
        //增加空表格
        PdfPCell p122 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "");
        PdfPRow pr122 = new PdfPRow (new PdfPCell[]{ p122});
        p122.setMinimumHeight(150);
        pt.getRows ().add (pr122);

        AppendEmptyLine (2,pt,2F);
        PdfPCell p13 = CreateCell (RowHeight,FontName, 14, false, -1, -1, "诊断提示：");
        PdfPRow pr3 = new PdfPRow (new PdfPCell[]{ p13});
        pt.getRows ().add (pr3);
        String[] strings = convertMath(obj.getDIAGNOSISPROMPT());
        PdfPCell p14 = null;
        for(String s:strings){
            p14 = CreateCell (RowHeight,FontName, -1, false, -1, -1, s);
            PdfPRow pr4 = new PdfPRow (new PdfPCell[]{ p14});
            pt.getRows ().add (pr4);
        }
        PdfPCell p144 = CreateCell (RowHeight,FontName, -1, false, -1, -1,"");
        PdfPRow pr144 = new PdfPRow (new PdfPCell[]{ p144});
        p144.setMinimumHeight(100);
        pt.getRows ().add (pr144);
        //AppendLine (1,pt,false,2F);
        return pt;
    }
    private PdfPTable CreateTable3(Fangshe obj,String str,String str1) throws Exception {
        PdfPTable pt = new PdfPTable (4);
        float[] widthes = new float[]{3F,5F,3F,5F};
        pt.setWidths(widthes);
        pt.setWidthPercentage (95F);
        PdfPCell p11 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "报告医师：");
        PdfPCell p12 = CreateCell (5F,FontName, -1, false, Element.ALIGN_RIGHT, -1, "");
        PdfPCell p13 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "审核医师：");
        PdfPCell p14 = CreateCell (5F,FontName, -1, false, Element.ALIGN_RIGHT, -1, "");
        if(StringUtils.isNoneBlank (str)){
            Image img = Image.getInstance(str);
            img.scalePercent (30);
            p12.addElement (img);
        }
        //跨两行
        p12.setRowspan(2);
        if(StringUtils.isNoneBlank (str1)){
            Image img1 = Image.getInstance(str1);
            img1.scalePercent (30);
            p14.addElement (img1);
        }
        //跨两行
        p14.setRowspan(2);
        PdfPRow pr1 = new PdfPRow (new PdfPCell[]{ p11, p12, p13, p14});
        pt.getRows ().add (pr1);
        //AppendLine (6,pt,false,2F);

        PdfPCell p21 = CreateCell (RowHeight,FontName, -1, false, -1, -1,obj.getREPORTDOCTOR());
        PdfPCell p22 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "");
        PdfPCell p23 = CreateCell (RowHeight,FontName, -1, false, -1, -1, obj.getAUDITINGDOCTOR());
        PdfPCell p24 = CreateCell (RowHeight,FontName, -1, false, -1, -1,"");
        PdfPRow pr2 = new PdfPRow (new PdfPCell[]{ p21,p22,p23,p24});
        pt.getRows ().add (pr2);


        PdfPCell p31 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "报告日期:");
        PdfPCell p32 = CreateCell (RowHeight,FontName, -1, false, -1, -1, obj.getREPORTDATE());
        PdfPCell p33 = CreateCell (RowHeight,FontName, -1, false, -1, -1, "审核日期:");
        PdfPCell p34 = CreateCell (RowHeight,FontName, -1, false, -1, -1,obj.getAUDITINGDATE());
        PdfPRow pr3 = new PdfPRow (new PdfPCell[]{ p31,p32,p33,p34});
        pt.getRows ().add (pr3);

        AppendLine (4,pt,false,2F);
        return pt;
    }

    private PdfPTable CreateTable4(Fangshe obj) throws Exception {
        PdfPTable pt = new PdfPTable (1);
        float[] widthes = new float[]{4F};
        pt.setWidths(widthes);
        pt.setWidthPercentage (95F);

        PdfPCell p11 = CreateCell (5F,FontName, -1, false,-1, -1, "注:此报告仅供参考,不作任何证明。                       电话:0763-2226116");

        //img.scaleToFit (p13.getWidth (), p13.getHeight ());

        PdfPRow pr1 = new PdfPRow (new PdfPCell[]{ p11});
        pt.getRows ().add (pr1);

        return pt;
    }

    private Font CreateFont(String fontName, float fontSize, boolean isBold) throws Exception {

        String fontFile = "c:\\windows\\Fonts\\Simsun.ttc";
        BaseFont bsFont = null;
        try {
            bsFont = BaseFont.createFont (fontFile+",0", BaseFont.IDENTITY_H, BaseFont.EMBEDDED);
        }
        catch (Exception e)
        {
            try {
                bsFont = BaseFont.createFont ("宋体", BaseFont.IDENTITY_H, BaseFont.EMBEDDED);
            } catch(Exception e2)
            {
                e2.printStackTrace ();
            }
        }
        if(bsFont==null)
        {
            throw new Exception ("bsFont==null");
        }
        Font font =null;
        if(fontSize>0)
        {
            font= new Font (bsFont, fontSize);
        }
        else
        {
            font= new Font (bsFont);
        }
        if(isBold)
        {
            font.setStyle (Font.BOLD);
        }
        return font;
    }

    private PdfPCell CreateCell(float H, String fontName, float fontSize, boolean isBold, int align, int colSpan, String text) throws Exception {
        String sText = text;
        sText = sText.replace ("\r", "").replace ("\n","");
        PdfPCell p1 = new PdfPCell (new Phrase (sText, CreateFont (fontName,fontSize, isBold)));
        p1.setMinimumHeight ((H>0?H:20F));


        if(align== PdfPCell.ALIGN_LEFT ||align== PdfPCell.ALIGN_CENTER ||align== PdfPCell.ALIGN_RIGHT  )
        {
            p1.setHorizontalAlignment (align);
        }
        else
        {
            p1.setHorizontalAlignment (PdfPCell.ALIGN_LEFT);
        }
        p1.setVerticalAlignment (PdfPCell.ALIGN_MIDDLE);

        if(colSpan>0)
        {
            p1.setColspan (colSpan);
        }
        p1.setBorder (Rectangle.NO_BORDER);
        return p1;
    }

    private void AppendEmptyLine(int cellCount , PdfPTable pt, float H)
    {
        PdfPCell[] cells = new PdfPCell[cellCount];

        for (int i = 0; i < cellCount;  i++)
        {
            cells[i] = new PdfPCell (new Paragraph (" "));
            cells[i].setMinimumHeight (20F);
            //cells[i].setFixedHeight (H);
            cells[i].setUseVariableBorders (true);
            cells[i].setBorderWidthBottom (1F);
            cells[i].setBorderWidthTop (1F);
            cells[i].setBorderWidthLeft (0F);
            cells[i].setBorderWidthRight (0F);
            cells[i].setBorderColorBottom (BaseColor.WHITE);
            cells[i].setBorderColorTop (BaseColor.WHITE);
            cells[i].setBorderColorLeft (BaseColor.WHITE);
            cells[i].setBorderColorRight (BaseColor.WHITE);
        }


        PdfPRow prow =  new PdfPRow(cells);
        pt.getRows ().add (prow);
    }
    private void AppendLine(int cellCount , PdfPTable pt,boolean isTop, float H)
    {
        PdfPCell[] cells = new PdfPCell[cellCount];

        for (int i = 0; i < cellCount;  i++)
        {
            cells[i] = new PdfPCell (new Paragraph (" "));
            cells[i].setFixedHeight (H);
            cells[i].setUseVariableBorders (true);
            cells[i].setBorderWidthBottom (1F);
            cells[i].setBorderWidthTop (1F);
            cells[i].setBorderWidthLeft (0F);
            cells[i].setBorderWidthRight (0F);
            if(isTop)
            {
                cells[i].setBorderColorBottom (BaseColor.WHITE);
                cells[i].setBorderColorTop (BaseColor.BLACK);
                cells[i].setBorderColorLeft (BaseColor.WHITE);
                cells[i].setBorderColorRight (BaseColor.WHITE);
            }
            else
            {

                cells[i].setBorderColorBottom (BaseColor.BLACK);
                cells[i].setBorderColorTop (BaseColor.WHITE);
                cells[i].setBorderColorLeft (BaseColor.WHITE);
                cells[i].setBorderColorRight (BaseColor.WHITE);
            }
        }
        PdfPRow prow =  new PdfPRow(cells);
        pt.getRows ().add (prow);
    }
    public Fangshe source() {
        return new Fangshe ("冯秋仪","女","61岁",
                "CT162361","普通外科二区","10","187855","",
                "上腹(CT)平扫 1 次","    平扫：腹盆腔内见巨大囊实性混杂信号包块影，大小约37cmX27cmX16cm，多房，边界大致清楚，实性部分形态不规则，信号不均匀，囊性部分局部内见间隔影，局部可见壁结节；子宫受压，内膜、肌层未见异常信号影。膀胱无充盈，未见明显异常。所见腹腔内见少量积液影，未见明确淋巴结肿大。右肾轻度扩张积液。",
                "                对比2020-3-21片  1、慢支肺气肿并肺部感染较前吸收。  2、右上肺外胸膜下、左肺下叶胸膜下结节并邻近增厚粘连，大致同前。  3、主动脉、冠状动脉硬化.","2019年9月21日","2019年9月21日","朱玉莉",
                "2019年9月21日","武义");
    }
}
