package com.xjgs.service;

import com.xjgs.dao.JDBCUtils;
import com.xjgs.dao.JDBCUtils3;
import com.xjgs.dao.JDBCUtils4;
import com.xjgs.dao.JDBCUtils5;
import com.xjgs.util.FileUtil;
import com.xjgs.util.FtpUtil;
import com.xjgs.util.Logger;
import com.xjgs.util.PDFHelper;
import com.xjgs.vo.ArchiveMaster;
import com.xjgs.vo.Archive_Detail;
import com.xjgs.vo.Fangshe;
import com.xjgs.vo.User;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang3.StringUtils;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import java.io.File;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.*;

public class PacsService {
    private  static Logger logger = new Logger();
    //下载超声pdf并填入文件表
    public void uploadRadiation(String patientId) {
        SimpleDateFormat dateFormat = new SimpleDateFormat ("yyyy-MM-dd");
        String format1 = dateFormat.format (new Date ());
        String rootPath = System.getProperty ("user.dir");
        rootPath = rootPath+"\\logs\\"+format1;
        File fs = new File (rootPath);
        if(!fs.isDirectory ()){
            fs.mkdirs ();
        }
        System.setProperty ("log.base",rootPath);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String format = sdf.format(new Date ());
        List<Archive_Detail> archive_details = getAssortIdBySource ("pacs");
        List<Fangshe> fangsheList = getRadiEntity (patientId);
        for(Fangshe fangshe : fangsheList){
            boolean flag = true;
            for (Archive_Detail archive_detail:archive_details) {
                if(archive_detail.getSubAssort ().equals (fangshe.getSource_id ()+"_"+fangshe.getACCESSIONNUMBER())){
                    flag = false;
                }
            }
            if(flag){
                UUID uuid = UUID.randomUUID();//UUID唯一识别
                String id = uuid.toString();
                id = id.replace("-", "");
                Date date = new Date();
                writeRadiEntity(fangshe,id,getXmlPath("path"), date);
            }
        }
        logger.log("患者记账号为："+patientId+"的超声数据已同步,同步时间:"+format);
    }
    public List<Fangshe> getRadiEntity(String patientId) {
        String sql = "select  ACCESSIONNUMBER,PROF,REQUESTEDPROCEDUREDESCRIPTION AS 检查部位,source_id,CLINICAL_ID, REPORTDATE as 报告日期,\n" +
                "AUDITINGDATE as 审核日期,PATIENT_ID as 检查号,INPATIENT_ID as 住院号,FIRSTNAME as 患者姓名,EXAMINEDATE \n" +
                "as 开始检查时间@,CONVERT(varchar, DATEPART(yy,REGISTERDATE))+'/'+\n" +
                "CONVERT(varchar,DATEPART(mm,REGISTERDATE))+'/'+CONVERT(varchar,DATEPART(dd,REGISTERDATE)) +'/'+RTRIM(ACCESSIONNUMBER)\n" +
                " +'/zip/' as path,REPORTDOCTOR AS 报告医生,AUDITINGDOCTOR AS 审核医生  from RIS_STUDIES where ACCESSIONNUMBER like'J%'\n" +
                "AND REPORTDATE is not null and SOURCE_ID is not null  and (PATIENTTYPE = '住院' or PATIENTTYPE='急诊') and CLINICAL_ID = ? order by REPORTDATE desc";

        Fangshe fangshe = null;
        List<Fangshe>fangsheList = new ArrayList<> ();
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement statement = null;
        Object[]parms = new Object[]{patientId};
        try {
            connection = JDBCUtils4.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            while (resultSet.next()) {
                fangshe = new Fangshe ();
                fangshe.setACCESSIONNUMBER (resultSet.getString ("ACCESSIONNUMBER"));
                fangshe.setSource_id (resultSet.getString ("source_id"));
                fangshe.setINPATIENT_ID (resultSet.getString ("住院号"));
                fangshe.setProf (convertProf (resultSet.getString ("PROF")));
                fangshe.setREQUESTEDPROCEDUREDESCRIPTION (resultSet.getString ("检查部位"));
                fangshe.setREPORTDOCTOR (convertName (resultSet.getString ("报告医生")));
                fangshe.setAUDITINGDOCTOR (convertName (resultSet.getString ("审核医生")));
                fangshe.setREPORTDATE(resultSet.getString("报告日期"));
                fangshe.setPath (resultSet.getString ("path"));
                if(null !=fangshe.getPath()){
                    fangsheList.add(fangshe);
                }
            }
        } catch (Exception e) {
            logger.log(e.toString());
        }
        finally {
            JDBCUtils.release(resultSet,statement,connection);
        }
        return fangsheList;
    }
    public void fanshe(String patientId){
        String temp =  System.getProperty("user.dir")+"\\temp";
        File fs = new File (temp);
        if(!fs.isDirectory ()){
            fs.mkdirs ();
        }
        String loccalPath = getXmlPath("path");
        ItextPdfImpl itextPdf = new ItextPdfImpl();
        List<Fangshe>fangsheList= getFangshe(patientId);
        List<Archive_Detail> archive_details = getAssortIdBySource ("pacs");
        Archive_Detail archiveDetail = null;
        for(Fangshe fangshe:fangsheList){
            boolean flag = true;
            for(Archive_Detail archive_detail:archive_details){
                if(archive_detail.getSubAssort ().equals(fangshe.getSource_id ()+"_"+fangshe.getACCESSIONNUMBER())){
                    flag = false;
                }
            }
            if(flag){
                String picPath = getPicPath(fangshe);
                String picPath1 = getPicPath1 (fangshe);
                UUID uuid = UUID.randomUUID();//UUID唯一识别
                String id = uuid.toString();
                id = id.replace("-", "");
                archiveDetail = new Archive_Detail();
                archiveDetail.setAssortId("EABEEB5D628449A7930F4C0A9953A754");
                archiveDetail.setSubAssort(fangshe.getSource_id ()+"_"+fangshe.getACCESSIONNUMBER());
                archiveDetail.setUploadDateTime(new Date());
                archiveDetail.setSource("pacs");
                archiveDetail.setFlag("0");
                archiveDetail.setTitle(fangshe.getREQUESTEDPROCEDUREDESCRIPTION().replaceAll ("\\s*",""));
                try {
                    ArchiveMaster archiveMaster = pacsGetHisId(fangshe.getSource_id());
                    if(StringUtils.isNoneBlank(archiveMaster.getPatientId ())){
                        ArchiveMaster archiveMaster1 = getMasterIdByPa(archiveMaster.getPatientId());
                        if(StringUtils.isNoneBlank(archiveMaster1.getId())){
                            archiveMaster.setId(archiveMaster1.getId());
                        }
                        else{
                            uploadHomePageByPid(archiveMaster.getPatientId());
                            ArchiveMaster id1 = getMasterIdByPa(archiveMaster.getPatientId());
                            archiveMaster.setId(id1.getId());
                        }
                        File file = new File("Z:\\pacs\\"+archiveMaster.getPatientId());
                        if(!file.isDirectory ()){
                            file.mkdirs();
                        }
                        boolean b = itextPdf.writePdf (fangshe,temp + "\\" + id + ".pdf",picPath,picPath1,fangshe.getProf ());
                        if(b && FileUtil.checkFileWritingOn(temp + "\\" + id + ".pdf")){
                            FileUtils.copyFile (new File (temp+"\\"+id+".pdf"),new File (/*loccalPath+"\\pacs\\"+*/"Z:\\pacs\\"+archiveMaster.getPatientId()+"\\"+id+".pdf"));
                            archiveDetail.setPdfPath(/*loccalPath+"\\pacs\\"*/"G:\\pdf\\pacs\\"+archiveMaster.getPatientId()+"\\"+id+".pdf");
                            archiveDetail.setMasterId(archiveMaster.getId());
                            File file1 = new File (archiveDetail.getPdfPath ());
                            if(file1.exists () && FileUtil.checkFileWritingOn(file1.getAbsolutePath())){
                                writeArchiveDetail(archiveDetail);
                            }
                        }
                    }
                }catch (Exception e){
                    logger.log(e.toString());
                }finally {
                    File file2 = new File (temp+"\\"+id+".pdf");
                    file2.delete ();
                }
            }
        }
    }
    public int writeArchiveDetail(Archive_Detail archiveDetail) {
        String sql = "insert into archive_detail(id,PDF_PATH,MasterID,UpLoadDateTime,AssortID,Source,SubAssort,Title,flag)values(replace(newid(), '-', '')," +
                "?,?,?,?,?,?,?,?)";
        Connection connection = null;
        PreparedStatement statement = null;
        Object[] parms = new Object[]{archiveDetail.getPdfPath(), archiveDetail.getMasterId(), archiveDetail.getUploadDateTime(), archiveDetail.getAssortId(), archiveDetail.getSource(), archiveDetail.getSubAssort(), archiveDetail.getTitle(), archiveDetail.getFlag()};
        int j = 0;
        try {
            connection = JDBCUtils3.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    if(parms[i] instanceof Date) {
                        parms[i] = new java.sql.Timestamp(((Date) parms[i]).getTime());
                    }
                    statement.setObject(i + 1, parms[i]);
                }
            }
            j = statement.executeUpdate();
        } catch (Exception e) {
            logger.log(e.toString());
        }finally {
            JDBCUtils.release(null,statement,connection);
        }
        return j;
    }
    public List<Fangshe> getFangshe(String patientId){
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement statement = null;
        String sql = "select ACCESSIONNUMBER,PROF,source_id,FIRSTNAME AS 姓名,PATIENTSEX AS 性别,PATIENTAGE AS 年龄,PATIENT_ID AS 检查号,\n" +
                "REQUESTINGDEPARTMENT AS 申请科室,BEDID AS 床号,INPATIENT_ID AS 住院号,CLINICAL_ID AS 门诊号,\n" +
                "REQUESTEDPROCEDUREDESCRIPTION AS 检查部位,EXAMINEDESCRIPTION AS 检查所见,DIAGNOSISPROMPT AS \n" +
                "诊断提示,CONVERT(varchar, DATEPART(yy,EXAMINEDATE))+'年'+CONVERT(varchar, DATEPART(mm,EXAMINEDATE))+'月'+\n" +
                "CONVERT(varchar, DATEPART(DD,EXAMINEDATE))+'日'AS 检查日期,CONVERT(varchar, DATEPART(yy,REPORTDATE))+'年'+\n" +
                "CONVERT(varchar, DATEPART(mm,REPORTDATE))+'月'+CONVERT(varchar, DATEPART(DD,REPORTDATE))+'日' AS 报告日期,\n" +
                "REPORTDOCTOR AS 报告医生,CONVERT(varchar, DATEPART(yy,AUDITINGDATE))+'年'+CONVERT(varchar, DATEPART(mm,AUDITINGDATE))+'月'+\n" +
                "CONVERT(varchar, DATEPART(DD,AUDITINGDATE))+'日'AS 审核日期,AUDITINGDOCTOR AS 审核医生 from RIS_STUDIES\n" +
                "where  CLINICAL_ID = ? order by REPORTDATE desc";
        Fangshe fangshe = null;
        List<Fangshe>fangsheList = new ArrayList<>();
        Object[]parms= new Object[]{patientId};;
        try {
            connection = JDBCUtils4.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            while (resultSet.next()){
                fangshe = new Fangshe();
                fangshe.setACCESSIONNUMBER (resultSet.getString ("ACCESSIONNUMBER"));
                fangshe.setProf (convertProf (resultSet.getString ("PROF")));
                fangshe.setSource_id(resultSet.getString("source_id"));
                fangshe.setFIRSTNAME(resultSet.getString("姓名"));
                fangshe.setPATIENTSEX(resultSet.getString("性别"));
                fangshe.setPATIENTAGE(resultSet.getString("年龄"));
                fangshe.setPATIENT_ID(resultSet.getString("检查号"));
                fangshe.setREQUESTINGDEPARTMENT(resultSet.getString("申请科室"));
                fangshe.setBEDID(resultSet.getString("床号"));
                fangshe.setINPATIENT_ID(resultSet.getString("门诊号"));
                fangshe.setCLINICAL_ID(resultSet.getString("住院号"));
                fangshe.setREQUESTEDPROCEDUREDESCRIPTION(resultSet.getString("检查部位"));
                fangshe.setEXAMINEDESCRIPTION(resultSet.getString("检查所见"));
                fangshe.setDIAGNOSISPROMPT(resultSet.getString("诊断提示"));
                fangshe.setEXAMINEDATE(resultSet.getString("检查日期"));
                fangshe.setREPORTDATE(resultSet.getString("报告日期"));
                fangshe.setREPORTDOCTOR(convertName (resultSet.getString("报告医生")));
                fangshe.setAUDITINGDATE(resultSet.getString("审核日期"));
                fangshe.setAUDITINGDOCTOR(convertName (resultSet.getString("审核医生")));
                fangsheList.add(fangshe);
            }
        } catch (Exception e) {
            logger.log(e.toString());
        }finally {
            JDBCUtils.release(resultSet,statement,connection);
        }
        return fangsheList;
    }
    public String convertName(String name){
        if(StringUtils.isNoneBlank (name)){
            String[] strings = name.split ("/");
            if(2 == strings.length){
                return  strings[0];
            }else {
                return name;
            }
        }else {
            return "";
        }
    }
    public ArchiveMaster pacsGetHisId(String sourceId){
        String sql = "select fvisit_id,fappnote_no from mp.smp_pacs_appnote where fappnote_no = ?";
        Object[]parms = new Object[]{sourceId};
        ArchiveMaster archiveMaster = null;
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement preparedStatement = null;
        try {
            connection = JDBCUtils.getConnection();
            preparedStatement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    preparedStatement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = preparedStatement.executeQuery();
            while (resultSet.next()){
                archiveMaster = new ArchiveMaster();
                archiveMaster.setPatientId(resultSet.getString("fvisit_id"));
            }
        } catch (SQLException e) {
            logger.log(e.toString());
        } catch (Exception e) {
            logger.log(e.toString());
        } finally {
            JDBCUtils.release(resultSet,preparedStatement,connection);
        }
        return archiveMaster == null ? new ArchiveMaster():archiveMaster;
    }
    public Integer writeRadiEntity(Fangshe fangshe, String id, String localPath, Date date) {
        String temp =  System.getProperty("user.dir")+"\\temp";
        File fs = new File (temp);
        if(!fs.isDirectory ()){
            fs.mkdirs ();
        }
        int j = 0;
        Connection connection = null;
        PreparedStatement statement = null;
        Archive_Detail archiveDetail = new Archive_Detail ();
        archiveDetail.setSubAssort (fangshe.getSource_id ());
        ArchiveMaster archiveMaster = pacsGetHisId (fangshe.getSource_id ());
        ArchiveMaster archiveMaster1 = null;
        if(StringUtils.isNoneBlank (archiveMaster.getPatientId ())) {
            try {
                archiveMaster1 = getMasterIdByPa (archiveMaster.getPatientId ());
                if (StringUtils.isNoneBlank(archiveMaster1.getId ())) {
                    archiveMaster.setId (archiveMaster1.getId ());
                } else {
                    uploadHomePageByPid (archiveMaster.getPatientId ());
                    ArchiveMaster id1 = getMasterIdByPa (archiveMaster.getPatientId ());
                    archiveMaster.setId (id1.getId ());
                }
                FtpUtil ftpUtil = new FtpUtil ();
                ftpUtil.downloadFile (fangshe.getPath (), "yun.pdf", temp, id + ".pdf");
                File fd = new File (temp+"\\"+id + ".pdf");
                if (fd.exists() && FileUtil.checkFileWritingOn(temp+"\\"+id + ".pdf")) {
                    String picPath = getPicPath (fangshe);
                    String picPath1 = getPicPath1 (fangshe);
                    archiveDetail.setPdfPath ((localPath + "\\pacs\\" + archiveMaster.getPatientId () + "\\" + id + ".pdf"));
                    File file = new File (localPath + "\\pacs\\" + archiveMaster.getPatientId ());
                    if (!file.isDirectory ()) {
                        file.mkdirs ();
                    }
                    PDFHelper.AddWatermark (temp + "\\" + id + ".pdf", picPath, picPath1, archiveDetail.getPdfPath ());
                    if (new File (archiveDetail.getPdfPath ()).exists () && FileUtil.checkFileWritingOn(archiveDetail.getPdfPath())) {
                        logger.log("准备添加文件信息");
                        archiveDetail.setMasterId (archiveMaster.getId ());
                        archiveDetail.setUploadDateTime (date);
                        archiveDetail.setAssortId ("EABEEB5D628449A7930F4C0A9953A754");
                        archiveDetail.setSource ("pacs");
                        archiveDetail.setFlag ("0");
                        archiveDetail.setSubAssort (fangshe.getSource_id ()+"_"+fangshe.getACCESSIONNUMBER());
                        archiveDetail.setTitle (fangshe.getREQUESTEDPROCEDUREDESCRIPTION ().replaceAll ("\\s*",""));
                        String sql = "insert into archive_detail(ID,PDF_PATH,MasterID,UpLoadDateTime,AssortID,Source,flag,title,SubAssort)values(replace(newid(), '-', ''),?,?,?,?,?,?,?,?)";
                        Object[] parms = new Object[]{archiveDetail.getPdfPath (), archiveDetail.getMasterId (), archiveDetail.getUploadDateTime (), archiveDetail.getAssortId (), archiveDetail.getSource (), archiveDetail.getFlag (), archiveDetail.getTitle (), archiveDetail.getSubAssort ()};
                        connection = JDBCUtils3.getConnection ();
                        statement = connection.prepareStatement (sql);
                        if (parms != null && parms.length > 0) {
                            for (int i = 0; i < parms.length; i++) {
                                statement.setObject (i + 1, parms[i]);
                            }
                        }
                        j = statement.executeUpdate ();
                    }
                }
            } catch (Exception e) {
                logger.log ("超声数据未同步_____"+archiveMaster.getPatientId ());
            } finally {
                File file = new File (temp + "\\" + id + ".pdf");
                file.delete ();
                JDBCUtils.release (null, statement, connection);
            }
        }
        return j;
    }
    public void uploadHomePageByPid(String patientId){
        String sql = "select  t.zyh as 住院号,t.jzh as 记账号,t.zycs as 住院次数,t.xm as 姓名,t.xb as 性别,t.ryrq as 入院日期,t.cyrq as 出院日期,t.sfzh as 身份证号,t.rybq as 入院科室,t.dqbq as 出院科室,t.rycw as 入院床位,hp.fdrname as 主管医生 " +
                "from ndns.zl t left join hthis.p_doctor hp on t.dqys = hp.fdrid where t.jzh = ? order by t.jzh desc";
        ArchiveMaster master = null;
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement statement = null;
        Object[]parms = new Object[]{patientId};
        try {
            connection = JDBCUtils.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            while (resultSet.next()) {
                master = new ArchiveMaster();
                master.setInpNo(resultSet.getString("住院号").trim());
                master.setPatientId(resultSet.getString("记账号").trim());
                master.setVisitId(resultSet.getString("住院次数"));
                master.setName(resultSet.getString("姓名"));
                master.setSex(resultSet.getString("性别"));
                master.setAdmissionDateTime(resultSet.getString("入院日期"));
                master.setDischargeDateTime(resultSet.getString("出院日期"));
                master.setIdNo(resultSet.getString("身份证号"));
                master.setDeptAdmissionTo(resultSet.getString("入院科室"));
                master.setDeptName(resultSet.getString("出院科室"));
                master.setDoctorInCharge(resultSet.getString("主管医生"));
                master.setBedId(resultSet.getString ("入院床位"));
                if(null == master.getDischargeDateTime()|| master.getDischargeDateTime().isEmpty()){
                    master.setStatus("在院");
                }else{
                    master.setStatus("归档中");
                }
                if ("2".equals(master.getSex())) {
                    master.setSex("女");
                } else {
                    master.setSex("男");
                }
                writeHomeEntity(master);
            }
        } catch (Exception e) {
            logger.log(e.toString());
        }
        finally {
            JDBCUtils.release(resultSet,statement,connection);
        }
    }
    //新增首页数据
    int writeHomeEntity(ArchiveMaster archiveMaster) {
        String sql = "insert into archive_master(id,patient_id,inp_no,visit_id,name,sex,dept_name,discharge_date_time," +
                "archivestate,admission_date_time,dept_admission_to,doctor_in_charge,id_no,bed_id)values(replace(newid(), '-', ''),?,?,?,?,?,?,?,?,?,?,?,?,?)";
        Object[] parms = new Object[]{archiveMaster.getPatientId(), archiveMaster.getInpNo(), archiveMaster.getVisitId(), archiveMaster.getName(), archiveMaster.getSex(), archiveMaster.getDeptName(), archiveMaster.getDischargeDateTime(), archiveMaster.getStatus(), archiveMaster.getAdmissionDateTime(), archiveMaster.getDeptAdmissionTo(), archiveMaster.getDoctorInCharge(), archiveMaster.getIdNo(),archiveMaster.getBedId ()};
        Connection connection = null;
        PreparedStatement statement = null;
        int j = 0;
        try {
            connection = JDBCUtils3.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            j = statement.executeUpdate();
        } catch (Exception e) {
            logger.log(e.toString());
        }finally {
            JDBCUtils.release(null,statement,connection);
        }
        return j;
    }
    public ArchiveMaster getMasterIdByPa(String jzh){
        String sql = "select ID,patient_id from archive_master where patient_id = ?";
        Object[]parms = new Object[]{jzh};
        ArchiveMaster archiveMaster = null;
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement statement = null;
        try {
            connection = JDBCUtils3.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            while (resultSet.next()){
                archiveMaster = new ArchiveMaster();
                archiveMaster.setId(resultSet.getString("ID"));
                archiveMaster.setPatientId(resultSet.getString("patient_id"));
            }
        } catch (Exception e) {
            logger.log(e.toString());
        }
        finally {
            JDBCUtils.release(resultSet,statement,connection);
        }
        return  archiveMaster == null ? new ArchiveMaster():archiveMaster;
    }
    public String getPicPath(Fangshe source){
        String path = getXmlPath("pic");
        User user = getUserEntity (source.getREPORTDOCTOR ());
        String str = "";
        if(StringUtils.isNoneBlank(user.getCode())){
            File file = new File (path+user.getCode ()+".png");
            if(file.exists ()){
                str = path+user.getCode ()+".png";
            }
            File file1 = new File (path+"介入科\\"+user.getCode ()+".png");
            if(file1.exists ()){
                str = path+"介入科\\"+user.getCode ()+".png";
            }
            File file2 = new File (path+"内镜中心\\"+user.getCode ()+".png");
            if(file2.exists ()){
                str = path+"内镜中心\\"+user.getCode ()+".png";
            }
            if(!StringUtils.isNoneBlank (str)){
                File file3 = new File (path+"B超\\"+source.getREPORTDOCTOR ()+".png");
                if(file3.exists ()){
                    str = path+"B超\\"+source.getREPORTDOCTOR ()+".png";
                }
                File file4 = new File (path+"病理\\"+source.getREPORTDOCTOR ()+".png");
                if(file4.exists ()){
                    str = path+"病理\\"+source.getREPORTDOCTOR ()+".png";
                }
            }
        }else{
            File file = new File (path+"B超\\"+source.getREPORTDOCTOR ()+".png");
            if(file.exists ()){
                str = path+"B超\\"+source.getREPORTDOCTOR ()+".png";
            }
            File file1 = new File (path+"病理\\"+source.getREPORTDOCTOR ()+".png");
            if(file1.exists ()){
                str = path+"病理\\"+source.getREPORTDOCTOR ()+".png";
            }
        }
        if(!StringUtils.isNoneBlank (str)){
            logger.log ("未签名医师:"+source.getProf ()+"-:"+source.getREPORTDOCTOR ());
        }
        return str;
    }
    public String getPicPath1(Fangshe source){
        String path = getXmlPath("pic");
        User user = getUserEntity (source.getAUDITINGDOCTOR ());
        String str = "";
        if(StringUtils.isNoneBlank(user.getCode())){
            File file = new File (path+user.getCode ()+".png");
            if(file.exists ()){
                str = path+user.getCode ()+".png";
            }
            File file1 = new File (path+"介入科\\"+user.getCode ()+".png");
            if(file1.exists ()){
                str = path+"介入科\\"+user.getCode ()+".png";
            }
            File file2 = new File (path+"内镜中心\\"+user.getCode ()+".png");
            if(file2.exists ()){
                str = path+"内镜中心\\"+user.getCode ()+".png";
            }
            if(!StringUtils.isNoneBlank (str)){
                File file3 = new File (path+"B超\\"+source.getAUDITINGDOCTOR ()+".png");
                if(file3.exists ()){
                    str = path+"B超\\"+source.getAUDITINGDOCTOR ()+".png";
                }
                File file4 = new File (path+"病理\\"+source.getAUDITINGDOCTOR ()+".png");
                if(file4.exists ()){
                    str = path+"病理\\"+source.getAUDITINGDOCTOR ()+".png";
                }
            }
        }else{
            File file = new File (path+"B超\\"+source.getAUDITINGDOCTOR ()+".png");
            if(file.exists ()){
                str = path+"B超\\"+source.getAUDITINGDOCTOR ()+".png";
            }
            File file1 = new File (path+"病理\\"+source.getAUDITINGDOCTOR ()+".png");
            if(file1.exists ()){
                str = path+"病理\\"+source.getAUDITINGDOCTOR ()+".png";
            }
        }
        if(!StringUtils.isNoneBlank (str)){
            logger.log ("未签名医师:"+source.getProf ()+"-:"+source.getAUDITINGDOCTOR ());
        }
        return str;
    }
    public User getUserEntity(String name){
        String sql = "select user_name from power_user where name=?";
        Object[]parms = new Object[]{name};
        Connection connection = null;
        PreparedStatement statement = null;
        ResultSet resultSet = null;
        User user = new User ();
        try {
            connection = JDBCUtils5.getConnection ();
            statement = connection.prepareStatement (sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery ();
            while (resultSet.next ()){
                user.setCode (resultSet.getString ("user_name"));
            }
        }catch (Exception ex){
            logger.log(ex.toString());
        }finally {
            JDBCUtils.release (resultSet,statement,connection);
        }
        return  user;
    }
    public String convertProf(String profName){
        Map<String,String>profMap = new HashMap<> ();
        profMap.put ("1","B超检查报告单");
        profMap.put ("2","CR检查报告单");
        profMap.put ("3","CT检查报告单");
        profMap.put ("4","MR检查报告单");
        profMap.put ("5","放射检查报告单");
        profMap.put ("6","DR检查报告单");
        profMap.put ("7","数字胃肠检查报告单");
        profMap.put ("8","DSA检查小C报告单");
        profMap.put ("9","DSA检查大C报告单");
        profMap.put ("20","骨密度检查报告单");
        profMap.put ("22","胃镜检查报告单");
        profMap.put ("23","肠镜检查报告单");
        profMap.put ("24","鼻咽喉镜检查报告单");
        profMap.put ("25","十二指肠镜检查报告单");
        profMap.put ("26","TCD检查报告单");
        profMap.put ("27","支气管检查报告单");
        profMap.put ("28","肺功能检查报告单");
        profMap.put ("29","心电图检查报告单");
        profMap.put ("30","病理检查报告单");
        profMap.put ("32","超声内镜报告单");
        profMap.put ("33","胶囊内镜检查报告单");
        profMap.put ("34","呼气试验检查报告单");
        profMap.put ("36","液基检查报告单");
        profMap.put ("37","细胞学检查报告单");
        profMap.put ("38","HPV检查报告单");
        profMap.put ("39","皮肤科检查报告单");
        if(StringUtils.isNoneBlank (profName)){
            return profMap.get (profName);
        }
        return "";
    }
    public List<Archive_Detail>getAssortIdBySource(String source){
        String sql = "select SubAssort from archive_detail where Source = ? order by UpLoadDateTime desc";
        Object[]parms = new Object[]{source};
        Archive_Detail archive_detail = null;
        List<Archive_Detail>details = new ArrayList<>();
        Connection connection = null;
        PreparedStatement statement = null;
        ResultSet resultSet = null;
        try {
            connection = JDBCUtils3.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            while (resultSet.next()){
                archive_detail = new Archive_Detail();
                archive_detail.setSubAssort(resultSet.getString("SubAssort"));
                details.add(archive_detail);
            }
        }catch (Exception e){
            logger.log(e.toString());
        }finally {
            JDBCUtils.release(resultSet,statement,connection);
        }
        return  details;
    }
    public String getXmlPath(String elementName) {
        Document doc = null;
        try {
            doc = new SAXReader ().read(this.getClass().getResourceAsStream("/localPath.xml"));
        } catch (DocumentException e) {
            e.printStackTrace();
        }
        Element root = doc.getRootElement();
        Iterator itr = root.elementIterator();
        while(itr.hasNext()){
            Element element = (Element)itr.next();
            if(elementName.equals(element.getName())){
                return element.getTextTrim();
            }
        }
        return "";
    }

    public String pacs(ArchiveMaster archiveMaster){
        return "";
    }




}
