package com.xjgs.util;

import com.itextpdf.text.Image;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;
import com.itextpdf.text.pdf.PdfTemplate;
import com.sun.glass.ui.Size;
import org.apache.commons.lang3.StringUtils;
import org.junit.Test;

import java.awt.*;
import java.io.*;
import java.util.UUID;

public class PDFHelper {


    public static void AddWatermark(String pdfPath, String img1, String img2,  String toPath) throws  Exception
    {
        String sFile = UUID.randomUUID().toString().replace("-", "").replace("{","").replace("}","")+".pdf";
        File tmpFile = new File(sFile);
        FileOutputStream outputStream = new FileOutputStream(tmpFile);
        PdfReader reader = new PdfReader(pdfPath);
        PdfStamper pdfStamper = new PdfStamper(reader, outputStream);
        try
        {
            float scaleP = 50;

            //这里是加第一个签名
            Image pImg1 = null;
            if(StringUtils.isNoneBlank (img1)){
                pImg1 = Image.getInstance(img1);
                pImg1.scalePercent(scaleP);
            }


            //第二个签名
            Image pImg2 = null;
            if(StringUtils.isNoneBlank (img2)){
                pImg2 = Image.getInstance(img2);
                pImg2.scalePercent(scaleP);
            }
            for (int i = 1; i <= reader.getNumberOfPages(); i++)
            {
                Rectangle pageSize = reader.getPageSize(i);
                PdfContentByte cb = pdfStamper.getOverContent(i);
                //设置签名位置
                if(null!=pImg1){
                    Point pt = new Point((int)(pageSize.getWidth() / 2 - pImg1.getScaledWidth() / 2-40), 45);
                    pImg1.setAbsolutePosition((float)pt.getX(), (float)pt.getY());
                    cb.addImage(pImg1);



                    Point pt2 = new Point((int)(pageSize.getWidth()  - pImg1.getScaledWidth() / 2-55), 45);
                    pImg2.setAbsolutePosition((float)pt2.getX(), (float)pt2.getY());
                    cb.addImage(pImg2);
                }
            }
        }
        finally
        {
            if(pdfStamper!= null)
            {
                pdfStamper.close();
            }
            if(outputStream!=null)
            {
                outputStream.close();
            }
            if(reader !=null) {
                reader.close();
            }
        }

        //复制文件到toFile
        copy(sFile, toPath);
    }


    private static   int bufferSize = 10;
    public static void copy(String source, String dest) throws  Exception {

        File fDest = new File(dest);
        if(fDest.isFile()&& fDest.exists())
        {
            fDest.delete();
        }

        InputStream in = null;
        OutputStream out = null;
        try {
            in = new FileInputStream(new File(source));
            out = new FileOutputStream(fDest);

            byte[] buffer = new byte[bufferSize];
            int len;

            while ((len = in.read(buffer)) > 0) {
                out.write(buffer, 0, len);
            }
        } catch (Exception e) {

        } finally {
            if(in!=null)
            {
                in.close();
            }
            if(out!=null)
            {
                out.close();
            }
        }
    }

    private static void AddBackImageTemplate(PdfContentByte cb, Size ptSize, String srcImgPath, float x, float y) throws Exception
    {
        PdfTemplate pdfTemplate = cb.createTemplate(ptSize.width, ptSize.height);
        Image pimg = Image.getInstance(srcImgPath);
        pimg.setAbsolutePosition(0, 0);
        pimg.scaleToFit(ptSize.width, ptSize.height);
        pdfTemplate.addImage(pimg);
        cb.addTemplate(pdfTemplate, x, y);
    }
}
